SystemOrganization addCategory: #'Slot-Class'!
SystemOrganization addCategory: #'Slot-ClassBuilder'!
SystemOrganization addCategory: #'Slot-Error'!
SystemOrganization addCategory: #'Slot-Layout'!
SystemOrganization addCategory: #'Slot-Layout-Test'!
SystemOrganization addCategory: #'Slot-LayoutBuilder'!
SystemOrganization addCategory: #'Slot-Traits'!
SystemOrganization addCategory: #'Slot-Traits-Test'!
SystemOrganization addCategory: #'Slot-Slot'!
SystemOrganization addCategory: #'Slot-Slot-Test'!
SystemOrganization addCategory: #'Slot-Slot-Modifier'!
SystemOrganization addCategory: #'Slot-Transformation'!
SystemOrganization addCategory: #'Slot-Test'!

Trait named: #TOne
	uses: {}
	category: 'Slot-Test'!

!TOne methodsFor: 'as yet unclassified' stamp: 'MartinDias 8/1/2012 00:06'!
one
	^ 1! !

Trait named: #TTwo
	uses: {}
	category: 'Slot-Test'!

!TTwo methodsFor: 'as yet unclassified' stamp: 'MartinDias 8/1/2012 00:11'!
two
	^ 2! !

!TraitTransformation methodsFor: '*Slot' stamp: 'ToonVerwaest 3/31/2011 23:03'!
composeWithLayout: aLayout
	^ subject composeWithLayout: aLayout! !

!ByteString methodsFor: '*Slot' stamp: 'ToonVerwaest 4/1/2011 03:57'!
asSlot
	^ self asSymbol asSlot! !

!TraitComposition methodsFor: '*Slot' stamp: 'ToonVerwaest 4/2/2011 20:49'!
composeWithLayout: aLayout
	| result |
	result := aLayout.
	transformations do: [ :aTransformation |
		result := aTransformation composeWithLayout: result ].
	^ result! !

!CompiledMethod class methodsFor: '*Slot' stamp: 'ToonVerwaest 3/28/2011 20:30'!
newInstanceFrom: oldInstance variable: variable size: instSize map: map
	"Create a new instance of the receiver based on the given old instance.
	The supplied map contains a mapping of the old instVar names into
	the receiver's instVars"
	| new |
	new := self newFrom: oldInstance.
	1 to: instSize do: 
		[:offset | map isArray
				ifTrue: [ |index|
					index := map at: offset.
					index > 0 ifTrue: [
						new
							instVarAt: offset
							put: (oldInstance instVarAt: index)]]
				ifFalse: [ |slotModification|
					slotModification := map modificationAt: offset.
					slotModification migrateAt: offset to: new from: oldInstance ]].
	^new! !

!Symbol methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 16:23'!
=> aSlot
	aSlot isBehavior
		ifTrue: [ ^ aSlot named: self].
	^ aSlot name: self;
		yourself! !

!Symbol methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:35'!
asSlot
	^ Slot named: self.! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:59'!
name: className inEnvironment: env subclassOf: newSuper type: type slots: slots classVariableNames: classVarString poolDictionaries: poolString category: category
	"Define a new class in the given environment"
	^self 
		name: className 
		inEnvironment: env 
		subclassOf: newSuper 
		type: type 
		slots: slots 
		classVariableNames: classVarString 
		poolDictionaries: poolString 
		category: category
		unsafe: false! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 20:27'!
name: className inEnvironment: env subclassOf: newSuper type: type slots: slots classVariableNames: classVarString poolDictionaries: poolString category: category unsafe: unsafe
	"Define a new class in the given environment.
	If unsafe is true do not run any validation checks.
	This facility is provided to implement important system changes."

	| oldClass instVarNames classVars copyOfOldClass copyOfOldTraitComposition copyOfOldClassTraitComposition newClass |
	environ := env.
	
	
	instVarNames := Array new: slots size.
	slots withIndexDo: [:slot :index|  instVarNames at: index put: slot name].
	
	classVars := (Scanner new scanFieldNames: classVarString) collect: [ :x | x asSymbol ].	"Validate the proposed name"
		
	unsafe
		ifFalse: [ 
			(self validateClassName: className)
				ifFalse: [ ^ nil ] ].
			
	oldClass := env at: className ifAbsent: [ nil ].
	
	oldClass isBehavior
		ifFalse: [ oldClass := nil ]
		ifTrue: [ 
			copyOfOldClass := oldClass copy.
			copyOfOldClass superclass addSubclass: copyOfOldClass.
			copyOfOldClass
				ifNotNil: [ 
					oldClass hasTraitComposition
						ifTrue: [ copyOfOldTraitComposition := oldClass traitComposition copyTraitExpression ].
					oldClass class hasTraitComposition
						ifTrue: [ copyOfOldClassTraitComposition := oldClass class traitComposition copyTraitExpression ] ] ].	"Already checked in #validateClassName:"
					
	[ 
	| newCategory oldCategory needNew force organization |
	unsafe
		ifFalse: [ 
			"Run validation checks so we know that we have a good chance for recompilation"
			(self validateSuperclass: newSuper forSubclass: oldClass)
				ifFalse: [ ^ nil ].
			(self validateInstvars: instVarNames from: oldClass forSuper: newSuper)
				ifFalse: [ ^ nil ].
			(self validateClassvars: classVars from: oldClass forSuper: newSuper)
				ifFalse: [ ^ nil ].
			"should go via layout"
			(self
				validateSubclassFormat: type
				from: oldClass
				forSuper: newSuper
				extra: instVarNames size)
				ifFalse: [ ^ nil ] ].	"See if we need a new subclass"
				
	needNew := self
		needsSubclassOf: newSuper
		type: type
		instanceVariables: instVarNames
		from: oldClass.
		
	needNew == nil
		ifTrue: [ ^ nil ].	"some error"
			
	(needNew and: [ unsafe not ])
		ifTrue: [ 
			"Make sure we don't redefine any dangerous classes"
			(self tooDangerousClasses includes: oldClass name)
				ifTrue: [ self error: oldClass name , ' cannot be changed' ].	"Check if the receiver should not be redefined"
					
			(oldClass ~~ nil and: [ oldClass shouldNotBeRedefined ])
				ifTrue: [ self notify: oldClass name asText allBold , ' should not be redefined. \Proceed to store over it.' withCRs ] ].
	needNew
		ifTrue: [ 
			"Create the new class"
			newClass := self
				newSubclassOf: newSuper
				type: type
				slots: slots
				from: oldClass.
			newClass == nil
				ifTrue: [ ^ nil ].	"Some error"
			newClass setName: className ]
		ifFalse: [ 
			"Reuse the old class"
			newClass := oldClass ].	"Install the class variables and pool dictionaries... "
			
	force := (newClass declare: classVarString) | (newClass sharing: poolString).	"... classify ..."
	newCategory := category asSymbol.
	organization := environ ifNotNil: [ environ organization ].
	oldClass isNil
		ifFalse: [ oldCategory := (organization categoryOfElement: oldClass name) asSymbol ].
		
	organization classify: newClass name under: newCategory.
	newClass environment: environ.	"... recompile ..."
		
	newClass := self
		recompile: force
		from: oldClass
		to: newClass
		mutate: false.	"... export if not yet done ..."
			
	(environ at: newClass name ifAbsent: [ nil ]) == newClass
		ifFalse: [ 
			environ at: newClass name put: newClass.
			Smalltalk globals flushClassNameCache ].	"... set trait composition..."
			
	copyOfOldTraitComposition ifNotNil: [ newClass setTraitComposition: copyOfOldTraitComposition ].
	copyOfOldClassTraitComposition ifNotNil: [ newClass class setTraitComposition: copyOfOldClassTraitComposition ].
	newClass doneCompiling.	"... notify interested clients ..."
		
	oldClass isNil
		ifTrue: [ 
			SystemChangeNotifier uniqueInstance classAdded: newClass inCategory: newCategory.
			^ newClass ].
		
	newCategory ~= oldCategory
		ifTrue: [ SystemChangeNotifier uniqueInstance class: newClass recategorizedFrom: oldCategory to: category ]
		ifFalse: [ SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: copyOfOldClass to: newClass ] ]
		ensure: [ 
			copyOfOldClass ifNotNil: [ copyOfOldClass superclass removeSubclass: copyOfOldClass ].
			Behavior flushObsoleteSubclasses ].
		
	^ newClass! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 15:35'!
newSubclassOf: newSuper type: type instanceVariables: instVars from: oldClass
	"Create a new subclass of the given superclass with the given specification."
	| newFormat newClass |
	"Compute the format of the new class"
	newFormat := 
		self computeFormat: type 
			instSize: instVars size 
			forSuper: newSuper 
			ccIndex: (oldClass ifNil:[0] ifNotNil:[oldClass indexIfCompact]).

	newFormat == nil
		ifTrue:[^nil].

	(oldClass == nil or:[oldClass isMeta not]) 
		ifTrue:[newClass := self privateNewSubclassOf: newSuper from: oldClass]
		ifFalse:[newClass := oldClass shallowCopy].

	newClass 
		superclass: newSuper
		methodDictionary: MethodDictionary new
		format: newFormat;
		setInstVarNames: instVars;
		initializeLayout. " build the default layout with normal slots"

	oldClass ifNotNil:[
		newClass organization: oldClass organization.
		"Recompile the new class"
		oldClass hasMethods 
			ifTrue:[newClass compileAllFrom: oldClass].		
		self recordClass: oldClass replacedBy: newClass].

	(oldClass == nil or:[oldClass isObsolete not]) 
		ifTrue:[newSuper addSubclass: newClass]
		ifFalse:[newSuper addObsoleteSubclass: newClass].

	^newClass! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 15:25'!
newSubclassOf: newSuper type: type slots: slots from: oldClass
	"Create a new subclass of the given superclass with the given specification."
	| newFormat newClass |
	"Compute the format of the new class"
	newFormat := 
		self computeFormat: type 
			instSize: slots size 
			forSuper: newSuper 
			ccIndex: (oldClass ifNil:[0] ifNotNil:[oldClass indexIfCompact]).

	newFormat == nil 
		ifTrue:[^nil].

	(oldClass == nil or:[oldClass isMeta not]) 
		ifTrue:[newClass := self privateNewSubclassOf: newSuper from: oldClass]
		ifFalse:[newClass := oldClass shallowCopy].

	newClass 
		superclass: newSuper
		methodDictionary: MethodDictionary new
		format: newFormat;
		initializeLayoutWithSlots: slots.

	oldClass ifNotNil:[
		newClass organization: oldClass organization.
		"Recompile the new class"
		oldClass hasMethods 
			ifTrue:[newClass compileAllFrom: oldClass].		
		self recordClass: oldClass replacedBy: newClass.
	].

	(oldClass == nil or:[oldClass isObsolete not]) 
		ifTrue:[newSuper addSubclass: newClass]
		ifFalse:[newSuper addObsoleteSubclass: newClass].

	^newClass! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 15:42'!
privateNewSubclassOf: newSuper
	"Create a new meta and non-meta subclass of newSuper"
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newSuperMeta newMeta |
	
	newSuperMeta := newSuper ifNil:[Class] ifNotNil:[newSuper class].
	newMeta := Metaclass new.
	
	newMeta 
		superclass: newSuperMeta 
		methodDictionary: MethodDictionary new 
		format: newSuperMeta format;
		initializeLayout. " build the default layout with normal slots"
		
	^newMeta new
! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 15:42'!
privateNewSubclassOf: newSuper from: oldClass
	"Create a new meta and non-meta subclass of newSuper using oldClass as template"
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newSuperMeta oldMeta newMeta |
	oldClass ifNil:[^self privateNewSubclassOf: newSuper].
	newSuperMeta := newSuper ifNil:[Class] ifNotNil:[newSuper class].
	
	oldMeta := oldClass class.
	newMeta := oldMeta shallowCopy.
	
	newMeta 
		superclass: newSuperMeta
		methodDictionary: MethodDictionary new
		format: (self computeFormat: oldMeta typeOfClass 
					instSize: oldMeta instVarNames size 
					forSuper: newSuperMeta
					ccIndex: 0);
		setInstVarNames: oldMeta instVarNames;
		organization: oldMeta organization;
		initializeLayout. " build the default layout with normal slots"
		
	"Recompile the meta class"
	oldMeta hasMethods 
		ifTrue:[newMeta compileAllFrom: oldMeta].
		
	"Record the meta class change"
	self recordClass: oldMeta replacedBy: newMeta.
	
	"And create a new instance"
	^ newMeta adoptInstance: oldClass from: oldMeta! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: newSuper
	subclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class."
	^self 
		name: t
		inEnvironment: newSuper environment
		subclassOf: newSuper
		type: newSuper typeOfClass
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: aClass
	variableByteSubclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable byte-sized nonpointer variables."
	| oldClassOrNil actualType |
	(aClass instSize > 0)
		ifTrue: [^self error: 'cannot make a byte subclass of a class with named fields'].
	(aClass isVariable and: [aClass isWords])
		ifTrue: [^self error: 'cannot make a byte subclass of a class with word fields'].
	(aClass isVariable and: [aClass isPointers])
		ifTrue: [^self error: 'cannot make a byte subclass of a class with pointer fields'].
	oldClassOrNil := aClass environment at: t ifAbsent:[nil].
	actualType := (oldClassOrNil notNil
				   and: [oldClassOrNil typeOfClass == #compiledMethod])
					ifTrue: [#compiledMethod]
					ifFalse: [#bytes].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: actualType
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: aClass
	variableSubclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable pointer variables."
	aClass isBits 
		ifTrue: [^self error: 'cannot make a pointer subclass of a class with non-pointer fields'].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #variable
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: aClass
	variableWordSubclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable word-sized nonpointer variables."
	(aClass instSize > 0)
		ifTrue: [^self error: 'cannot make a word subclass of a class with named fields'].
	(aClass isVariable and: [aClass isBytes])
		ifTrue: [^self error: 'cannot make a word subclass of a class with byte fields'].
	(aClass isVariable and: [aClass isPointers])
		ifTrue: [^self error: 'cannot make a word subclass of a class with pointer fields'].

	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #words
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!ClassBuilder methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:58'!
superclass: aClass
	weakSubclass: t slots: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver) in which the subclass is to 
	have weak indexable pointer variables."
	aClass isBits 
		ifTrue: [^self error: 'cannot make a pointer subclass of a class with non-pointer fields'].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #weak
		slots: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

Error subclass: #SlotNotFound
	instanceVariableNames: 'name targetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!SlotNotFound class methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 18:53'!
signalForName: aSymbol
	self new
		name: aSymbol;
		signal! !

!SlotNotFound class methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 18:55'!
signalForName: aSymbol inClass: aClass
	self new
		name: aSymbol;
		targetClass: aClass;
		signal! !

!SlotNotFound methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/23/2011 14:22'!
messageText
	^ 'Slot ''', name asString, ''' not found', (targetClass ifNil: [''] ifNotNil:[' in ', targetClass name])! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
name
	^ name! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
name: anObject
	name := anObject! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:55'!
targetClass
	^ targetClass! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
targetClass: aClass
	targetClass := aClass! !

!TraitDescription methodsFor: '*Slot' stamp: 'ToonVerwaest 3/31/2011 23:04'!
composeWithLayout: aLayout
	" Standard traits don't have any state "
	^ aLayout! !

Exception subclass: #SlotClassBuilderConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!SlotClassBuilderConflict commentStamp: '<historical>' prior: 0!
I represent an error raised while building a class.!

SlotClassBuilderConflict subclass: #CircularHierarchyConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

SlotClassBuilderConflict subclass: #InvalidGlobalNameConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!InvalidGlobalNameConflict commentStamp: '<historical>' prior: 0!
I am an error raised by SlotClassBuilder.!

SlotClassBuilderConflict subclass: #InvalidSlotNameConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

SlotClassBuilderConflict subclass: #PrimitiveTypeConflict
	instanceVariableNames: 'layout subType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!PrimitiveTypeConflict commentStamp: '<historical>' prior: 0!
I am an error raised when extending a class with an incompatible layout!

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
layout
	^ layout! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
layout: anObject
	layout := anObject! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:30'!
messageText
	^ 'Class with ', layout class name, ' cannot be extended as ', subType! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
subType
	^ subType! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
subType: anObject
	subType := anObject! !

!SlotClassBuilderConflict methodsFor: 'exceptiondescription' stamp: 'ToonVerwaest 3/21/2011 01:12'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	UnhandledError signalForException: self! !

!SlotClassBuilderConflict methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:13'!
isResumable
	"Determine whether an exception is resumable."

	^ false! !

SlotClassBuilderConflict subclass: #SlotDuplicationConflict
	instanceVariableNames: 'newSlot oldSlot host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!SlotDuplicationConflict commentStamp: '<historical>' prior: 0!
I am an error raised when generating a duplicated slot !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:15'!
host
	^ host! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:15'!
host: anObject
	host := anObject! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:17'!
messageText
	^ 'Slot #''', oldSlot name, ''' appeared twice in ', host name! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
newSlot
	^ newSlot! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
newSlot: anObject
	newSlot := anObject! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
oldSlot
	^ oldSlot! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
oldSlot: anObject
	oldSlot := anObject! !

TestCase subclass: #SlotClassBuilderTest
	instanceVariableNames: 'aClass announcement announcementsCount instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Test'!

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 7/31/2012 01:45'!
aClassName
	^ #NewSlotTestObject! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 7/31/2012 01:48'!
anotherClassName
	^ #NewSlotTestObject2! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 23:22'!
assertOnlyOneAnnouncementOf: anAnnouncement within: aBlock
	SystemAnnouncer uniqueInstance weak on: anAnnouncement send: #countAnnouncements: to: self.
	aBlock value.
	self assert: announcementsCount <= 1! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 01:47'!
buildClassWith: anUnaryBlock
	"I build a class for testing, providing basic default values, but eventually customized by the received unary block."

	^PharoClassInstaller make: [:builder|
		builder
			superclass: Object;
			name: self aClassName;
			layoutClass: PointerLayout;
			category: 'SlotTestTmp'.
		anUnaryBlock value: builder
		].! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 22:11'!
buildClassWithLayout: aClassLayout
	^self buildClassWithLayout: aClassLayout andSlots: {}! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 01:39'!
buildClassWithLayout: aClassLayout andSlots: someSlots
	"
	I create a class using the Slot class builder given a class layout and a collection of slots.
	"

	^self buildClassWith: [:builder|
		builder
			layoutClass: aClassLayout;
			slots: someSlots
		].! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 23:11'!
countAnnouncements: anAnnouncement 
	announcementsCount := announcementsCount + 1! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 23:09'!
saveAnnouncement: anAnnouncement
	announcement := anAnnouncement! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 23:09'!
saveAnnouncementOnce: anAnnouncement
	announcement ifNotNil: [ ^self ].
	announcement := anAnnouncement! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 7/31/2012 01:47'!
setUp
	super setUp.
	announcementsCount := 0.! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 01:35'!
silentlyBuildClassWith: anUnaryBlock
	"
	I build a class for testing, providing basic default values, but eventually customized by the received unary block.
	I do it silently so I do not put side effects on the system
	"
	
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		^self buildClassWith: anUnaryBlock
	]! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 22:50'!
silentlyBuildClassWithLayout: aClassLayout
	^self silentlyBuildClassWithLayout: aClassLayout andSlots: {}! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'GuillermoPolito 7/30/2012 22:52'!
silentlyBuildClassWithLayout: aClassLayout andSlots: someSlots
	"
	I create a class using the Slot class builder given a class layout and a collection of slots.
	I do it silently so I do not put side effects on the system
	"
	
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		^self buildClassWithLayout: aClassLayout andSlots: someSlots.
	]! !

!SlotClassBuilderTest methodsFor: 'helpers' stamp: 'MartinDias 7/31/2012 00:41'!
silentlyCompile: sourceCode in: someClass
	"
	I compile a method in a class.
	I do it silently so I do not put side effects on the system
	"
	
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		someClass compile: sourceCode classified: 'test'
	]! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 7/31/2012 01:50'!
tearDown
	"We remove the classes that could have been created during test run"
	super tearDown.
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		{ self aClassName. self anotherClassName } do: [ :each | 
			Smalltalk at: each ifPresent: [ :class | class removeFromSystem ] ]
	].
	SystemAnnouncer uniqueInstance unsubscribe: self.! !

!SlotClassBuilderTest methodsFor: 'tests-class slot migrations' stamp: 'MartinDias 8/6/2012 17:39'!
testAddClassSlotAndMigrate

	| classAdded classModified |
	classAdded := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a) ].

	classAdded instVarNamed: #a put: $A.
	
	classModified := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a b) ].
	
	self assert: (classModified instVarNamed: #a) equals: $A.
	self assert: (classModified instVarNamed: #b) isNil.! !

!SlotClassBuilderTest methodsFor: 'tests-migrations' stamp: 'MartinDias 8/6/2012 16:09'!
testAddSlotAndMigrate
	"We create a class without slots and create an instance; then we add a slot and check the instance can hold a value."
	| classAdded classModified |
	classAdded := self silentlyBuildClassWithLayout: PointerLayout.
	
	instance := classAdded new.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #aSlot => Slot }.
	
	"it should have an instance variable"
	instance instVarAt: 1 put: 125.! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/2/2012 02:30'!
testByteToPointerInvalidExtension
	"Tests that an error is raised when extending a byte class with a pointer subclass."

	aClass := self silentlyBuildClassWithLayout: ByteLayout.

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: aClass;
				name: self anotherClassName;
				layoutClass: PointerLayout ] ]
		raise: SlotClassBuilderConflict.! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'GuillermoPolito 7/31/2012 07:42'!
testClassFormatChangedAnnounced
	| classAdded classModified |
	SystemAnnouncer uniqueInstance weak on: ClassModifiedClassDefinition send: #saveAnnouncementOnce: to: self.
	
	"We create a new class without slots"
	classAdded := self buildClassWithLayout: PointerLayout.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self buildClassWithLayout: WeakLayout.
	
	self assert: announcement item equals: classModified.
	self assert: announcement oldItem format equals: classAdded format.
	self assert: announcement item format equals: classModified format.! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:24'!
testClassNameMustBeCapitalized

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder name: #aNotCapitalizedClassName  ] ]
		raise: InvalidGlobalNameConflict! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:24'!
testClassNameMustBeSymbol

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder name: 'NotSymbolClassName'  ] ]
		raise: InvalidGlobalNameConflict! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:24'!
testClassNameWithInvalidCharacter

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder name: #'Invalid-ClassName'  ] ]
		raise: InvalidGlobalNameConflict.
		
	self flag: 'remove class if present!!'! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 18:20'!
testClassWithClassTrait

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: TOne ].
	
	self assert: (aClass class canUnderstand: #one).
	self assert: aClass one equals: 1.! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/1/2012 00:15'!
testClassWithTrait

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: TOne ].
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:19'!
testCompiledMethodLayout
	self assert: (CompiledMethod layout isKindOf: CompiledMethodLayout).! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:23'!
testDirectCircularHierarchyError
	"Tests an error is raised when trying to create a heirarchy A<-A"
	
	| classA classB |
	classA := self silentlyBuildClassWith: [ :builder |
			builder 
				superclass: Object;
				name: self aClassName ].

	self should: [ 
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: classA;
				name: self aClassName ] ]
		raise: CircularHierarchyConflict ! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:23'!
testIndirectCircularHierarchyError
	"Tests an error is raised when trying to create a heirarchy A<-B<-A"
	
	| classA classB |
	classA := self silentlyBuildClassWith: [ :builder |
			builder 
				superclass: Object;
				name: self aClassName ].

	classB := self silentlyBuildClassWith: [ :builder |
			builder 
				superclass: classA;
				name: self anotherClassName ].

	self should: [ 
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: classB;
				name: self aClassName ] ]
		raise: CircularHierarchyConflict ! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 18:21'!
testModifyClassTraitComposition
	"Tests that when modifing the trait composition on class-side, the old methods are removed from the method dictionary, and the new ones are added."

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: TOne ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: TTwo ].
	
	self deny: (aClass class canUnderstand: #one).
	self assert: (aClass class canUnderstand: #two).
! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 18:22'!
testModifyTraitComposition
	"Tests that when modifing the trait composition, the old methods are removed from the method dictionary, and the new ones are added."

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: TOne ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: TTwo ].
	
	self deny: (aClass canUnderstand: #one).
	self assert: (aClass canUnderstand: #two).
! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'GuillermoPolito 7/30/2012 23:23'!
testNewClassAddedAnnouncedOnlyOnce
	self assertOnlyOneAnnouncementOf: ClassAdded within: [
		"We create a new class without slots"
		self buildClassWithLayout: PointerLayout.
	]! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'GuillermoPolito 7/30/2012 23:11'!
testNewClassAnnounced
	| classAdded |
	SystemAnnouncer uniqueInstance weak on: ClassAdded send: #saveAnnouncement: to: self.
	
	classAdded := self buildClassWithLayout: PointerLayout.
	
	self assert: announcement item equals: classAdded.! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'GuillermoPolito 7/31/2012 02:14'!
testNewClassDefinitionAnnounced
	| classAdded classModified |
	SystemAnnouncer uniqueInstance weak on: ClassModifiedClassDefinition send: #saveAnnouncementOnce: to: self.
	
	"We create a new class without slots"
	classAdded := self buildClassWithLayout: PointerLayout.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self buildClassWithLayout: PointerLayout andSlots: { #aSlot => Slot }.
	
	self assert: announcement item equals: classModified.
	self assert: announcement oldItem allInstVarNames equals: classAdded allInstVarNames.! !

!SlotClassBuilderTest methodsFor: 'tests-announcements' stamp: 'GuillermoPolito 7/30/2012 23:22'!
testNewClassDefinitionAnnouncedOnlyOnce
	
	self assertOnlyOneAnnouncementOf: ClassModifiedClassDefinition within: [
		
		"We create a new class without slots"
		self buildClassWithLayout: PointerLayout.
		
		"now we extend it with slots.  The class definition should've changed"
		self buildClassWithLayout: PointerLayout andSlots: { #aSlot => Slot }.
	]! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewPointerClass

	aClass := self silentlyBuildClassWithLayout: PointerLayout.
	
	self deny: aClass isCompact.
	self assert: aClass isPointers.
	self assert: aClass isFixed.
	self assert: aClass instVarNames isEmpty.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewPointerClassWithVariables

	aClass := self 
		silentlyBuildClassWithLayout: PointerLayout
		andSlots: {
			#id => Slot.
			#name => Slot
		}.
	
	self assert: (aClass instVarNames includes: 'id').
	self assert: (aClass instVarNames includes: 'name').! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewVariableByteClass

	aClass := self silentlyBuildClassWithLayout: ByteLayout.
	
	self deny: aClass isCompact.
	self deny: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isBytes.
	self assert: aClass isVariable.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewVariableWordClass

	aClass := self silentlyBuildClassWithLayout: WordLayout.
	
	self deny: aClass isCompact.
	self deny: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isWords.
	self assert: aClass isVariable.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:51'!
testNewWeakClass

	aClass := self silentlyBuildClassWithLayout: WeakLayout.
	
	self deny: aClass isCompact.
	self assert: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isWords.
	self assert: aClass isWeak.! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/31/2012 23:52'!
testPointerWithSlotsToByteInvalidExtension
	"Tests that an error is raised when extending a class with slots, with a byte subclass."

	aClass := self 
		silentlyBuildClassWithLayout: PointerLayout
		andSlots: { #a => Slot }.

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: aClass;
				name: self anotherClassName;
				layoutClass: ByteLayout ] ]
		raise: PrimitiveTypeConflict! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/31/2012 23:52'!
testPointerWithSlotsToWordInvalidExtension
	"Tests that an error is raised when extending a class with slots, with a word subclass."

	aClass := self 
		silentlyBuildClassWithLayout: PointerLayout
		andSlots: { #a => Slot }.

	self should: [
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: aClass;
				name: self anotherClassName;
				layoutClass: WordLayout ] ]
		raise: PrimitiveTypeConflict! !

!SlotClassBuilderTest methodsFor: 'tests-class slot migrations' stamp: 'MartinDias 8/6/2012 17:30'!
testRemoveClassSlotAndMigrate

	| classAdded classModified |
	classAdded := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a b) ].

	classAdded instVarNamed: #a put: $A.
	
	classModified := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a) ].
	
	self assert: (classModified instVarNamed: #a) equals: $A.
	self should: (classModified instVarNamed: #b) raise: Error
! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 18:23'!
testRemoveClassTrait
	"Tests that when removing a trait from class-side, its methods are removed from the method dictionary."

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: TOne ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classTraitComposition: {} ].
	
	self deny: (aClass class canUnderstand: #one).
! !

!SlotClassBuilderTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/31/2012 01:07'!
testRemoveSlotAndMigrate
	"We create a class with a slot and create an instance; then we remove the slot and check the instance doesn't hold the value."
	| classAdded classModified |
	classAdded := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #aSlot => Slot }.

	instance := classAdded new.
	"it should have an instance variable"
	instance instVarAt: 1 put: 125.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self silentlyBuildClassWithLayout: PointerLayout.
	
	self should: [ instance instVarAt: 1 ] raise: Error.! !

!SlotClassBuilderTest methodsFor: 'tests-traits' stamp: 'MartinDias 8/6/2012 18:22'!
testRemoveTrait
	"Tests that when removing a trait from a class, its methods are removed from the method dictionary."

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: TOne ].

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder traitComposition: {} ].
	
	self deny: (aClass canUnderstand: #one).
! !

!SlotClassBuilderTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/31/2012 01:07'!
testShiftSlotAndMigrate
	| classAdded classModified |
	classAdded := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #a => Slot . #c => Slot }.
	self silentlyCompile: 'a ^a' in: classAdded.
	self silentlyCompile: 'c ^c' in: classAdded.
	
	instance := classAdded new.
	instance instVarNamed: #a put: 1.
	instance instVarNamed: #c put: 3.

	"now we extend it with slots.  The class definition should've changed"
	classModified := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #a => Slot . #b => Slot . #c => Slot }.

	"it should have added an instance variable with nil in the middle"
	self assert: (instance instVarAt: 1) equals: 1.
	self assert: (instance instVarAt: 2) equals: nil.
	self assert: (instance instVarAt: 3) equals: 3.
	
	self assert: (instance instVarNamed: #a) equals: 1.
	self assert: (instance instVarNamed: #b) equals: nil.
	self assert: (instance instVarNamed: #c) equals: 3.
	
	"it should have migrated methods"
	self assert: instance a equals: 1.
	self assert: instance c equals: 3.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'MartinDias 7/31/2012 01:47'!
testSlotBuilderBuildsClass

	aClass := self silentlyBuildClassWithLayout: PointerLayout.
	
	self assert: (Smalltalk classNamed: self aClassName) == aClass.
	self assert: aClass name = self aClassName.
	self deny: aClass layout isNil.! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/31/2012 01:56'!
testSlotDuplicationConflict

	aClass := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #a => Slot }.

	self should: [ 
		self silentlyBuildClassWith: [ :builder | 
			builder 
				superclass: aClass;
				name: self anotherClassName;
				slots: { #a => Slot } ] ]
		raise: SlotDuplicationConflict ! !

!SlotClassBuilderTest methodsFor: 'tests-errors' stamp: 'MartinDias 8/6/2012 11:25'!
testSlotWithReservedName

	#(#self #super #thisContext #true #false #nil) do: [:reservedName |
		self should: [ 
			self silentlyBuildClassWithLayout: PointerLayout andSlots: { reservedName => Slot } ]
			raise: InvalidSlotNameConflict ]! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'GuillermoPolito 7/30/2012 22:20'!
testSmallIntegerLayout
	self assert: (SmallInteger layout isKindOf: SmallIntegerLayout).! !

!SlotClassBuilderTest methodsFor: 'tests-class slot migrations' stamp: 'MartinDias 8/6/2012 17:52'!
testSwitchClassSlotAndMigrate

	| classAdded classModified |	
	classAdded := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(a b) ].

	"Add methods"	
	self silentlyCompile: 'a ^a' in: classAdded class.
	self silentlyCompile: 'b ^b' in: classAdded class.

	"Put values"
	classAdded instVarNamed: #a put: $A.
	classAdded instVarNamed: #b put: $B.

	"Modify the class"	
	classModified := 
		self silentlyBuildClassWith: [ :builder | 
			builder classSlots: #(b a) ].
	
	"The instance was migrated"
	self assert: (classModified instVarNamed: #a) equals: $A.
	self assert: (classModified instVarNamed: #b) equals: $B.
	
	"The methods were migrated"
	self assert: classModified a equals: $a.
	self assert: classModified b equals: $b.
! !

!SlotClassBuilderTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/31/2012 01:07'!
testSwitchSlotsAndMigrate
	| classAdded classModified |
	classAdded := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #a => Slot . #b => Slot }.
	self silentlyCompile: 'a ^a' in: classAdded.
	self silentlyCompile: 'b ^b' in: classAdded.

	instance := classAdded new.
	instance instVarNamed: #a put: $A.
	instance instVarNamed: #b put: $B.

	"now we switch the slots. The class definition should've changed"
	classModified := self silentlyBuildClassWithLayout: PointerLayout andSlots: { #b => Slot . #a => Slot }.

	self assert: (instance instVarAt: 1) equals: $B.
	self assert: (instance instVarAt: 2) equals: $A.
	
	self assert: (instance instVarNamed: #a) equals: $A.
	self assert: (instance instVarNamed: #b) equals: $B.

	"it should have migrated methods"
	self assert: instance a equals: $A.
	self assert: instance b equals: $B.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'MartinDias 8/6/2012 16:27'!
testWithClassSlots

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classSlots: #(a) ].
	
	self assert: aClass class instVarNames equals: #(a).	
	aClass instVarNamed: 'a' put: $A.
	self assert: (aClass instVarNamed: 'a') equals: $A.! !

!SlotClassBuilderTest methodsFor: 'tests-layouts' stamp: 'MartinDias 8/6/2012 16:22'!
testWithoutClassSlots

	aClass := self silentlyBuildClassWith: [ :builder | 
		builder classSlots: #() ].
	
	self assert: aClass classVarNames equals: #()! !

Object subclass: #AbstractClassInstaller
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractClassInstaller class methodsFor: 'building' stamp: 'ToonVerwaest 3/22/2011 19:12'!
make: aBlock
	| builder |
	builder := self new builder.
	aBlock value: builder.
	^ builder build! !

!AbstractClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:42'!
builder
	^ builder! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:43'!
classAdded: aClass inCategory: aCategory
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:44'!
classAt: aName ifAbsent: aBlock
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionDeeplyChangedFrom: oldClass to: newClass by: classModification
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionShallowChangedFrom: oldClass to: newClass by: classModification
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'traits' stamp: 'ToonVerwaest 4/2/2011 20:51'!
copyTraitCompositionFrom: old to: new
	self installTraitComposition: old traitComposition copyTraitExpression on: new.
		! !

!AbstractClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:45'!
environment: anEnvironment
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/22/2011 17:43'!
initialize
	builder := SlotClassBuilder new.
	builder client: self! !

!AbstractClassInstaller methodsFor: 'traits' stamp: 'ToonVerwaest 4/2/2011 23:47'!
installTraitComposition: aTraitComposition on: aClass
	self flag: 'Should probably send something else to test'.
	aTraitComposition == NilTraitComposition instance
		ifTrue: [ aClass setTraitComposition: {} asTraitComposition ]
		ifFalse: [ aClass setTraitComposition: aTraitComposition ]
		
	! !

!AbstractClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:30'!
migrateClasses: old to: new using: anInstanceModification
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:44'!
recategorize: aClass to: aCategory
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'CamilloBruni 3/29/2011 11:23'!
superclassChangedOf: aClass to: newClass by: classModification
	self subclassResponsibility.! !

AbstractClassInstaller subclass: #AnonymousClassBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:45'!
classAdded: aClass inCategory: aCategory! !

!AnonymousClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:46'!
classAt: aName ifAbsent: aBlock
	^ aBlock value! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionDeeplyChangedFrom: oldClass to: newClass by: classModification! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionShallowChangedFrom: oldClass to: newClass by: classModification! !

!AnonymousClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:46'!
environment: anEnvironment! !

!AnonymousClassBuilder methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:30'!
migrateClasses: old to: new using: anInstanceModification! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:46'!
recategorize: aClass to: aCategory! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'CamilloBruni 3/29/2011 11:23'!
superclassChangedOf: aClass to: newClass by: classModification! !

AbstractClassInstaller subclass: #PharoClassInstaller
	instanceVariableNames: 'environment instanceModification methodUpdateStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!PharoClassInstaller methodsFor: 'notifications' stamp: 'GuillermoPolito 7/30/2012 22:25'!
classAdded: aClass inCategory: aCategory
	" Install the new class in the system "
	environment at: aClass name put: aClass.
	environment flushClassNameCache.
	" Update the system's organization "
	environment organization classify: aClass name under: aCategory.
	self systemEventNotifier classAdded: aClass inCategory: aCategory.
	" Inform superclass of new subclass "
	aClass superclass addSubclass: aClass.! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:03'!
classAt: aName ifAbsent: aBlock
	^ (environment at: aName ifAbsent: aBlock)
		ifNil: aBlock! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'GuillermoPolito 7/30/2012 22:25'!
classDefinitionChangedFrom: oldClass to: newClass by: classModification
	self copyMethodsFrom: oldClass to: newClass using: classModification.
	" Copy over the trait composition "
	self copyTraitCompositionFrom: oldClass to: oldClass.
	" Copy over the method organization "
	newClass organization: oldClass organization.
	" Update the superclass links "
	oldClass superclass == newClass superclass ifFalse: [ 
		oldClass superclass removeSubclass: oldClass.
		newClass superclass addSubclass: newClass ].
	self systemEventNotifier classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'GuillermoPolito 7/30/2012 22:25'!
classFormatChangedFrom: oldClass to: newClass by: classModification
	self systemEventNotifier classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'MartinDias 7/30/2012 00:08'!
copyMethodsFrom: oldClass to: newClass using: classModification
	methodUpdateStrategy
		transform: oldClass
		to: newClass
		using: classModification methodModification! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 16:55'!
environment: anEnvironment
	environment := anEnvironment! !

!PharoClassInstaller methodsFor: 'initialize-release' stamp: 'MartinDias 7/30/2012 00:03'!
initialize
	super initialize.
	environment := nil environment.
	methodUpdateStrategy := MethodRecompileStrategy new.! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:34'!
migrateClasses: old to: new using: anInstanceModification
	instanceModification := anInstanceModification.
	old size > 0 
		ifTrue: [ [
			1 to: old size do: [ :index |
				self updateClass: (old at: index) to: (new at: index)].
			old elementsForwardIdentityTo: new.
			" Garbage collect away the zombie instances left behind in garbage memory in #updateInstancesFrom: "
			" If we don't clean up this garbage, a second update would revive them with a wrong layout!! "
			" (newClass rather than oldClass, since they are now both newClass) "
			Smalltalk garbageCollect.
		] valueUnpreemptively ]! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'GuillermoPolito 7/30/2012 22:25'!
recategorize: aClass to: aCategory
	aClass category ~~ aCategory ifTrue: [
		environment organization classify: aClass name under: aCategory.
		self systemEventNotifier class: aClass recategorizedFrom: aClass category to: aCategory ]! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'GuillermoPolito 7/30/2012 22:25'!
shallowClassDefinitionChangedFrom: oldClass to: newClass by: classModification
	self shallowCopyMethodsFrom: oldClass to: newClass using: classModification.
	" Copy over the trait composition "
	self copyTraitCompositionFrom: oldClass to: oldClass.
	" Copy over the method organization "
	newClass organization: oldClass organization.
	" Update the superclass links "
	oldClass superclass == newClass superclass ifFalse: [ 
		oldClass superclass removeSubclass: oldClass.
		newClass superclass addSubclass: newClass ].
	self systemEventNotifier classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:54'!
shallowCopyMethodsFrom: oldClass to: newClass using: classModification
	newClass methodDict: oldClass methodDict! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'GuillermoPolito 7/30/2012 22:25'!
superclassChangedOf: aClass to: newClass by: classModification
	|oldClass|
	oldClass := aClass copy.
	aClass superclass removeSubclass: aClass.
	aClass superclass: newClass.
	newClass addSubclass: aClass.
	self systemEventNotifier classDefinitionChangedFrom: oldClass to: aClass.! !

!PharoClassInstaller methodsFor: 'private' stamp: 'GuillermoPolito 7/30/2012 22:25'!
systemEventNotifier
	^ SystemAnnouncer uniqueInstance! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/23/2011 23:57'!
updateClass: oldClass to: newClass
	| compactClassIndex |
	compactClassIndex := oldClass indexIfCompact.
	compactClassIndex > 0
		ifTrue: [ newClass layout compactClassIndex: compactClassIndex ].
	self updateInstancesFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'CamilloBruni 3/29/2011 19:32'!
updateInstancesFrom: old to: new
	| oldInstances variable instSize newInstances |
	oldInstances := old allInstances asArray.
	variable := new isVariable.
	instSize := new instSize.
	newInstances := Array new: oldInstances size.
	1 to: oldInstances size do:[:i|
		newInstances at: i put: (
			new newInstanceFrom: (oldInstances at: i) 
				 variable: variable 
				 size: instSize 
				 map: instanceModification)].
	oldInstances elementsForwardIdentityTo: newInstances.! !

Object subclass: #AbstractClassModification
	instanceVariableNames: 'target layout propagations newClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractClassModification methodsFor: 'public' stamp: 'ToonVerwaest 4/1/2011 17:49'!
apply
	^ newClass := target shallowCopy
		superclass: self superclass
		layout: layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'CamilloBruni 3/30/2011 19:27'!
checkSanity
	layout checkSanity.! !

!AbstractClassModification methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:20'!
computeChange
	self checkSanity.! !

!AbstractClassModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 03:31'!
initialize
	propagations := OrderedCollection new.! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 13:50'!
layout
	^ layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:07'!
layout: aLayout
	layout := aLayout.
	layout host: target.
	layout finalize.
	self computeChange! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:49'!
newClass
	^ newClass! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:24'!
newLayout
	^ layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:38'!
oldLayout
	^ target layout! !

!AbstractClassModification methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:16'!
propagate
	target subclassesDo: [ :subclass |
		propagations add:
			(ClassModificationPropagation
				propagate: self
				to: subclass) ]
	
		! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:19'!
propagationsDo: aBlock
	propagations do: [ :aPropagation |
		aBlock value: aPropagation.
		aPropagation propagationsDo: aBlock ]! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 19:53'!
result
	^ target! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:40'!
target
	^ target! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/19/2011 15:57'!
target: aTarget
	target := aTarget! !

AbstractClassModification subclass: #ClassModification
	instanceVariableNames: 'ownSlotStart superclass additions removals changes subclassSlotOffset slotShift methodModification copies traitComposition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ClassModification class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:28'!
modify: aClass extend: aSuperclass withLayoutType: layoutClass slots: someSlots traitComposition: aTraitComposition
	^ self new
		target: aClass;
		superclass: aSuperclass;
		traitComposition: aTraitComposition;
		layoutType: layoutClass	slots: someSlots! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:30'!
additions: aCollection
	additions := aCollection! !

!ClassModification methodsFor: 'private' stamp: 'CamilloBruni 3/29/2011 19:00'!
buildModificationMapFor: aModification
	aModification slotShift: (ShiftedField new shift: slotShift).
	
	aModification size = 0 
		ifTrue: [ ^ aModification ].
	
	additions do: [ :slot | 
		self installSlotAddition: slot on: aModification].
	
	changes keysAndValuesDo: [ :newSlot :oldSlot | 
		self installSlotChangeFrom: oldSlot to: newSlot on: aModification ].
	
	removals do: [ :slot | 
		self installSlotRemoval: slot on: aModification].
	
	copies keysAndValuesDo: [ :newSlot :oldSlot | 
		self installSlotCopiedFrom: oldSlot to: newSlot on: aModification ].
	
	^ aModification! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:49'!
changes
	^ changes! !

!ClassModification methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:21'!
computeChange
	super computeChange.
	layout computeChangesFrom: target layout in: self.
	slotShift := layout fieldSize - target layout fieldSize.
	self propagate.! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:45'!
copies
	^ copies! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 02:00'!
formatChange
	^ (layout format = target layout format) not! !

!ClassModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 03:31'!
initialize
	super initialize.
	changes := IdentityDictionary new.
	copies := IdentityDictionary new.
	removals := {}.
	additions := {}.! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotAddition: slot on: aModification
	0 to: slot size - 1 do: [ :idx |
		(AddedField new
			newSlot: slot;
			fieldIndex: idx) installOn: aModification  ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotChangeFrom: oldSlot to: newSlot on: aModification
	0 to: newSlot size - 1 do: [ :idx |
 		(ModifiedField new
			newSlot: newSlot;
			originalSlot: oldSlot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/30/2011 13:41'!
installSlotCopiedFrom: oldSlot to: newSlot on: aModification
	0 to: newSlot size - 1 do: [ :idx |
 		(UnmodifiedField new
			slot: newSlot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotRemoval: slot on: aModification
	0 to: slot size - 1 do: [ :idx |
		(RemovedField new
			originalSlot: slot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:45'!
instanceModification
	| map |
	map := InstanceModification new: layout fieldSize.
	^ self buildModificationMapFor: map! !

!ClassModification methodsFor: 'accessing' stamp: 'MartinDias 7/30/2012 01:30'!
layoutType: layoutType slots: slotArray
	| parentLayout newScope |
	parentLayout := self parentLayout.
	newScope := parentLayout slotScope extend: slotArray.
	self layout: (layoutType buildFrom: parentLayout scope: newScope host: self target)! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:27'!
methodModification
	^ methodModification ifNil: [
		methodModification := MethodModification new: target layout fieldSize.
		self buildModificationMapFor: methodModification ]! !

!ClassModification methodsFor: 'testing' stamp: 'ToonVerwaest 3/31/2011 21:17'!
modifiesFormat
	^ (layout format = target layout format) not! !

!ClassModification methodsFor: 'testing' stamp: 'ToonVerwaest 3/30/2011 15:31'!
modifiesSlots
	^ (changes isEmpty and: [ removals isEmpty and: [ additions isEmpty ]]) not! !

!ClassModification methodsFor: 'testing' stamp: 'CamilloBruni 3/24/2011 23:56'!
modifiesSuperclass
	^ (target superclass == superclass) not! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:04'!
newScope
	^ layout slotScope! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:03'!
originalScope
	^ target layout slotScope! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:15'!
parentLayout
	^ traitComposition composeWithLayout: self superLayout! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:30'!
removals: aCollection
	removals := aCollection! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 23:32'!
slotShift
	^ slotShift! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:25'!
subclassSlotOffset
	^ subclassSlotOffset! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:15'!
superLayout
	^ superclass
		ifNil: [ NilLayout instance ]
		ifNotNil: [ superclass layout ]! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:34'!
superclass
	^ superclass! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:32'!
superclass: aClass
	superclass := aClass! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 19:48'!
traitComposition
	^ traitComposition! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 20:54'!
traitComposition: aTraitComposition
	" We copy the trait composition since we might want "
	" to update the slot indices if the composition is partly stateful "
	traitComposition := aTraitComposition copyTraitExpression! !

AbstractClassModification subclass: #ClassModificationPropagation
	instanceVariableNames: 'origin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ClassModificationPropagation class methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/20/2011 14:51'!
propagate: aModification to: aClass
	^ self new
		propagate: aModification
		to: aClass! !

!ClassModificationPropagation methodsFor: 'migrating' stamp: 'ToonVerwaest 3/27/2011 21:14'!
methodModification
	^ origin methodModification! !

!ClassModificationPropagation methodsFor: 'public' stamp: 'ToonVerwaest 4/1/2011 18:16'!
propagate: aModification to: aTarget
	origin := aModification.
	target := aTarget.
	self layout: (target layout reshapeFrom: origin oldLayout slotScope to: origin newLayout).! !

!ClassModificationPropagation methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:50'!
superclass
	^ origin newClass! !

Object subclass: #AbstractFieldModification
	instanceVariableNames: 'fieldIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractFieldModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
fieldIndex
	^ fieldIndex! !

!AbstractFieldModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
fieldIndex: anObject
	fieldIndex := anObject! !

!AbstractFieldModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:07'!
installOn: aModification
	self subclassResponsibility! !

!AbstractFieldModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:31'!
migrateAt: index to: newInstance from: oldInstance! !

AbstractFieldModification subclass: #AddedField
	instanceVariableNames: 'newSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AddedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:07'!
installOn: aModification
	aModification installAddedSlot: self! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 19:48'!
name
	^ newSlot name! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
newFieldIndex
	^ newSlot index + fieldIndex! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:35'!
newSlot
	^ newSlot! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:35'!
newSlot: anObject
	newSlot := anObject! !

AbstractFieldModification subclass: #ModifiedField
	instanceVariableNames: 'newSlot originalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ModifiedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:08'!
installOn: aModification
	aModification installModifiedSlot: self! !

!ModifiedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:54'!
migrateAt: index to: newInstance from: oldInstance
	newInstance
		instVarAt: index
		put: (oldInstance instVarAt: self oldFieldIndex)! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
newFieldIndex
	^ newSlot index + fieldIndex! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
newSlot
	^ newSlot! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
newSlot: anObject
	newSlot := anObject! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
oldFieldIndex
	^ originalSlot index + fieldIndex! !

!ModifiedField methodsFor: 'accessing' stamp: 'CamilloBruni 3/28/2011 18:50'!
originalSlot

	^ originalSlot! !

!ModifiedField methodsFor: 'accessing' stamp: 'CamilloBruni 3/28/2011 18:50'!
originalSlot: anObject
	originalSlot := anObject! !

AbstractFieldModification subclass: #RemovedField
	instanceVariableNames: 'originalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!RemovedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:08'!
installOn: aModification
	aModification installRemovedSlot: self! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
oldFieldIndex
	^ originalSlot index + fieldIndex! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
originalSlot
	^ originalSlot! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
originalSlot: anObject
	originalSlot := anObject! !

AbstractFieldModification subclass: #ShiftedField
	instanceVariableNames: 'shift'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ShiftedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:31'!
migrateAt: index to: newInstance from: oldInstance
	newInstance instVarAt: index put: (oldInstance instVarAt: index - shift)! !

!ShiftedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:27'!
shift
	^ shift! !

!ShiftedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:27'!
shift: anObject
	shift := anObject! !

AbstractFieldModification subclass: #UnmodifiedField
	instanceVariableNames: 'slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:27'!
fieldIndex
	^ slot index + fieldIndex! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:28'!
installOn: aModification
	aModification installUnmodifiedSlot: self! !

!UnmodifiedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:55'!
migrateAt: index to: newInstance from: oldInstance
	newInstance
		instVarAt: index
		put: (oldInstance instVarAt: index)! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:48'!
slot
	^ slot! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:48'!
slot: anObject
	slot := anObject! !

Object subclass: #AbstractLayout
	instanceVariableNames: 'host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/3/2011 22:58'!
allSlots
	^ {}! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:07'!
allVisibleSlots
	^ {}! !

!AbstractLayout methodsFor: 'validation' stamp: 'ToonVerwaest 4/1/2011 03:38'!
checkSanity
	host ifNil: [ self error: 'Host should not be nil' ].! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
fieldSize
	^ 0! !

!AbstractLayout methodsFor: 'finalization' stamp: 'ToonVerwaest 4/7/2011 12:08'!
finalize
	self allSlotsDo: [ :aSlot | aSlot finalize: self ]! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
hasFields
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
hasSlots
	^ false! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:52'!
host
	^ host! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:52'!
host: anObject
	host := anObject! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:38'!
instanceVariables
	^ {}! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isBits
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isVariable
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isWeak
	^ false! !

!AbstractLayout methodsFor: 'printing' stamp: 'ToonVerwaest 4/1/2011 03:39'!
printSlotDefinitionOn: aStream
	aStream << '{}'! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:10'!
resolveSlot: aName
	self flag: 'Signal rather than error'.
	self error: 'No slots found'! !

AbstractLayout subclass: #NilLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

NilLayout class
	instanceVariableNames: 'instance'!

NilLayout class
	instanceVariableNames: 'instance'!

!NilLayout class methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/20/2011 15:29'!
instance
	^ instance ifNil: [ instance := self new ]! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:26'!
extend: someSlots
	^ PointerLayout new
		slotScope: (LayoutEmptyScope instance extend: someSlots)! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendByte
	^ ByteLayout new! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:26'!
extendVariable: someSlots
	^ VariableLayout new
		slotScope: (LayoutEmptyScope extend: someSlots)! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:57'!
extendWeak
	^ WeakLayout new! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendWord
	^ WordLayout new! !

!NilLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
fieldSize
	^ 0! !

!NilLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
hasFields
	^ false! !

!NilLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
hasSlots
	^ false! !

!NilLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 17:30'!
slotScope
	^ LayoutEmptyScope instance! !

AbstractLayout subclass: #ObjectLayout
	instanceVariableNames: 'compactClassIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

ObjectLayout subclass: #BitsLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!BitsLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:53'!
initializeInstance: anInstance! !

!BitsLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:25'!
isBits
	^ true! !

!BitsLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

BitsLayout subclass: #ByteLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!ByteLayout class methodsFor: 'instance creation' stamp: 'MartinDias 8/1/2012 00:27'!
buildFrom: superLayout scope: aScope host: aClass
	self flag: #todo. "Seems that #extendByte already checks for #hasFields, so next code shouldnt be needed, right?"
	"	aScope hasFields 
		ifTrue: [ self error: 'No fields expected!!' ]."
	^ superLayout extendByte
		host: aClass;
		yourself! !

!ByteLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 8! !

BitsLayout subclass: #WordLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!WordLayout class methodsFor: 'instance creation' stamp: 'MartinDias 8/1/2012 00:27'!
buildFrom: superLayout scope: aScope host: aClass
	self flag: #todo. "Seems that #extendByte already checks for #hasFields, so next code shouldnt be needed, right?"
"	aScope hasFields 
		ifTrue: [ self error: 'No fields expected!!' ].
"	^ superLayout extendWord
		host: aClass;
		yourself! !

!WordLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 6! !

ObjectLayout subclass: #CompiledMethodLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!CompiledMethodLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 15:58'!
format
	^ 3586! !

!CompiledMethodLayout methodsFor: 'initialize-release' stamp: 'CamilloBruni 10/16/2011 20:21'!
initialize
	super initialize.
	self host: CompiledMethod.! !

ObjectLayout subclass: #LayoutWithSlots
	instanceVariableNames: 'slotScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:23'!
allSlots
	^ slotScope flatten! !

!LayoutWithSlots methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/1/2011 01:54'!
allSlotsDo: aBlock
	slotScope allSlotsDo: aBlock! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/4/2011 13:30'!
allVisibleSlots
	^ slotScope allVisibleSlots! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'CamilloBruni 4/4/2011 13:20'!
atName: aName
	^ slotScope atName: aName! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'ToonVerwaest 4/1/2011 14:03'!
atName: aName ifAbsent: aBlock
	^ slotScope atName: aName ifAbsent: aBlock! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'ToonVerwaest 4/1/2011 02:02'!
checkSanity
	super checkSanity.
	self checkSlotNames.
	self checkSlotIndices.! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'ToonVerwaest 4/1/2011 02:43'!
checkSlotIndices
	| slots current |
	slots := slotScope flatten.
	[ slots size > 1 ] whileTrue: [
		current := slots removeFirst.
		self assert: slots first index = (current index + current size) ]! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'ToonVerwaest 4/3/2011 16:01'!
checkSlotNames
	| slots current |
	slots := slotScope allVisibleSlots.
	[ slots isEmpty ] whileFalse: [
		current := slots removeLast.
		slots do: [ :other |
			other name == current name
				ifTrue: [ 
					SlotDuplicationConflict new
						oldSlot: current;
						newSlot: other;
						host: host;
						signal ]]]! !

!LayoutWithSlots methodsFor: 'diff' stamp: 'ToonVerwaest 4/7/2011 11:53'!
computeChangesFrom: other in: modification
	| additions changes removals copies |
	other hasSlots ifFalse: [ ^ modification additions: self allSlots asArray ].
	
	additions := self allSlots.
	removals := OrderedCollection new.
	copies := modification copies.
	changes := modification changes.
	
	other allSlots do: [ :oldSlot |
		(self popSlot: oldSlot from: additions)
			ifNil: [ removals add: oldSlot ]
			ifNotNil: [ :newSlot |
				newSlot = oldSlot
					ifTrue: [ copies at: newSlot put: oldSlot ]
					ifFalse: [ changes at: newSlot put: oldSlot ]]].
			
	modification
		additions: additions asArray;
		removals: removals asArray.! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'CamilloBruni 4/4/2011 15:39'!
extend: aScope
	^ self species new slotScope: aScope! !

!LayoutWithSlots methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 03:25'!
extendAgain: aLayout with: someScope
	| result |
	result := aLayout copy.
	result slotScope: someScope.
	^ result! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:31'!
extendVariable: newScope
	^ VariableLayout new slotScope: newScope! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:31'!
extendWeak: newScope
	^ WeakLayout new slotScope: newScope! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:28'!
fieldSize
	^ slotScope fieldSize! !

!LayoutWithSlots methodsFor: 'forking' stamp: 'MartinDias 7/30/2012 01:39'!
forkLayout: aLayout
	| forkScope |
	forkScope := slotScope forkScope: aLayout slotScope.
 	^ aLayout species buildFrom: self scope: forkScope host: self host! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:16'!
hasFields
	^ slotScope hasFields! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:25'!
hasSlots
	^ slotScope hasSlots! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'ToonVerwaest 4/1/2011 15:26'!
includesName: aName
	self atName: aName ifAbsent: [ ^ false ].
	^ true! !

!LayoutWithSlots methodsFor: 'instance initialization' stamp: 'ToonVerwaest 4/1/2011 01:54'!
initializeInstance: anInstance
	self allSlotsDo: [ :slot | slot initialize: anInstance ]! !

!LayoutWithSlots methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:33'!
instanceSpecification
	| base |
	base := self instanceSpecificationBase.
	^ self hasFields
		ifTrue: [ base + 1 ]
		ifFalse: [ base ]! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/4/2011 13:48'!
instanceVariables
	^ slotScope visibleSlotNames! !

!LayoutWithSlots methodsFor: 'diff' stamp: 'ToonVerwaest 4/1/2011 02:45'!
popSlot: aSlot from: collection
	collection withIndexDo: [ :slot :index |
		slot name == aSlot name
			ifTrue: [ ^ collection removeAt: index ]].
	^ nil! !

!LayoutWithSlots methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 21:00'!
postCopy
	slotScope := slotScope copy! !

!LayoutWithSlots methodsFor: 'printing' stamp: 'ToonVerwaest 4/1/2011 01:40'!
printSlotDefinitionOn: aStream
	slotScope printSlotDefinitionOn: aStream! !

!LayoutWithSlots methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 18:16'!
reshapeFrom: oldScope to: newLayout
	| newScope |
	newScope := slotScope rebase: oldScope to: newLayout slotScope.
	^ newLayout extendAgain: self with: newScope.! !

!LayoutWithSlots methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 17:24'!
reshapeTo: aModification
	| newScope |
	newScope := slotScope rebase: aModification originalScope to: aModification newScope.
	^ aModification newLayout extendAgain: self with: newScope.! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:10'!
resolveSlot: aName
	^ slotScope atName: aName! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:20'!
size 
	^ slotScope fieldSize! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 10/16/2011 20:12'!
slotAt: index
	self flag: 'clean..'.
	^ self allSlots at: index! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:13'!
slotScope
	^ slotScope! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:13'!
slotScope: anObject
	slotScope := anObject! !

LayoutWithSlots subclass: #PointerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!PointerLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:43'!
buildFrom: superLayout scope: aScope host: aClass
	^ (superLayout extend: aScope)
		host: aClass;
		yourself! !

!PointerLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecificationBase
	^ 0! !

LayoutWithSlots subclass: #VariableLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!VariableLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:43'!
buildFrom: superLayout scope: aScope host: aClass
	^ (superLayout extendVariable: aScope)
		host: aClass;
		yourself! !

!VariableLayout methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 02:55'!
extendAgain: aLayout with: someScope
	| result |
	result := self species new.
	result host: aLayout host.
	aLayout compactClassIndex > 0
		ifTrue: [ result compactClassIndex: aLayout compactClassIndex ].
	result slotScope: someScope.
	^ result! !

!VariableLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecificationBase
	^ 2! !

!VariableLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

LayoutWithSlots subclass: #WeakLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!WeakLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:44'!
buildFrom: superLayout scope: aScope host: aClass
	^ (superLayout extendWeak: aScope)
		host: aClass;
		yourself! !

!WeakLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 4! !

!WeakLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

!WeakLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isWeak
	^ true! !

!ObjectLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:40'!
buildFrom: superLayout scope: aScope host: aClass
	self subclassResponsibility! !

!ObjectLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:35'!
compactClassIndex: anIndex
	compactClassIndex := anIndex.
	host setFormat: self format! !

!ObjectLayout methodsFor: 'diff' stamp: 'ToonVerwaest 4/1/2011 02:22'!
computeChangesFrom: other in: modification
	other hasSlots ifTrue: [
		modification removals: other allSlots asArray ]! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:25'!
extend: aScope
	PrimitiveTypeConflict new
		layout: self;
		subType: #slot;
		signal! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendByte
	self hasFields ifTrue: [
		PrimitiveTypeConflict new
			layout: self;
			subType: #byte;
			signal ].
	^ ByteLayout new! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:26'!
extendVariable: aScope
	PrimitiveTypeConflict new
		layout: self;
		subType: #variable;
		signal! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendWord
	self hasFields ifTrue: [
		PrimitiveTypeConflict new
			layout: self;
			subType: #word;
			signal ].
	^ WordLayout new! !

!ObjectLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:34'!
format
	| fieldSize sizeHiBits format |
	fieldSize := self fieldSize + 1.
	sizeHiBits := fieldSize // 64.
	format := sizeHiBits.
	format := (format bitShift: 5) + compactClassIndex.
	format := (format bitShift: 4) + self instanceSpecification.
	format := (format bitShift: 6) + (fieldSize \\ 64).
	format := (format bitShift: 1).
	^ format! !

!ObjectLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:34'!
initialize
	compactClassIndex := 0! !

!ObjectLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:53'!
initializeInstance: anInstance
	self subclassResponsibility! !

!ObjectLayout methodsFor: 'reshaping' stamp: 'MartinDias 7/30/2012 01:39'!
reshapeTo: aModification
	^ self class buildFrom: aModification layout scope: LayoutEmptyScope instance host: self host! !

ObjectLayout subclass: #SmallIntegerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!SmallIntegerLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:32'!
extend: newScope
	^ PointerLayout new slotScope: newScope! !

!SmallIntegerLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 04:12'!
format
	^ 2! !

!SmallIntegerLayout methodsFor: 'initialize-release' stamp: 'CamilloBruni 10/16/2011 20:21'!
initialize
	super initialize.
	self host: SmallInteger.! !

!SmallIntegerLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 17:32'!
slotScope
	^ LayoutEmptyScope instance! !

Object subclass: #AbstractMethodUpdateStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractMethodUpdateStrategy methodsFor: 'updating' stamp: 'MartinDias 7/30/2012 00:08'!
transform: oldClass to: newClass using: aMethodModification

	self subclassResponsibility ! !

AbstractMethodUpdateStrategy subclass: #MethodRecompileStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!MethodRecompileStrategy methodsFor: 'updating' stamp: 'MartinDias 7/30/2012 00:07'!
transform: oldClass to: newClass using: aMethodModification

	newClass compileAllFrom: oldClass
! !

Object subclass: #AbstractModification
	instanceVariableNames: 'slotShift modificationMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractModification commentStamp: '<historical>' prior: 0!
Modifications to a high-level class have an impact on the related low-level structures. There are two modification models that transform the high-level model into concrete low-level modifications models, the method mod- ification model and the instance modification model. Both models list for every field, whether it was added, removed, or shifted to a new position.

Instance Variables:
	slotShift	<ProtoObject | PseudoContext>
	modificationMap	<(Collection of: AbstractFieldModification)>!

!AbstractModification class methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 3/24/2011 12:17'!
new: anInteger
	^ self new initialize: anInteger ! !

!AbstractModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/28/2011 19:46'!
initialize: anInteger
	self initialize.
	modificationMap := Array new: anInteger.! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installAddedSlot: addedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installModifiedSlot: modifiedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installRemovedSlot: removedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:29'!
installUnmodifiedSlot: unmodifiedSlot
	modificationMap
		at: unmodifiedSlot fieldIndex
		put: unmodifiedSlot! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/30/2011 13:52'!
modificationAt: idx
	idx > modificationMap size 
		ifTrue: [ ^ slotShift ].
	^ modificationMap at: idx! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/24/2011 12:18'!
size
	^ modificationMap size.! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/24/2011 11:37'!
slotShift: aShift
	slotShift := aShift! !

AbstractModification subclass: #InstanceModification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:13'!
installAddedSlot: addedSlot
	modificationMap at: addedSlot newFieldIndex put: addedSlot! !

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
installModifiedSlot: modifiedSlot
	modificationMap at: modifiedSlot newFieldIndex put: modifiedSlot! !

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
installRemovedSlot: removedSlot
	" ignore "! !

AbstractModification subclass: #MethodModification
	instanceVariableNames: 'addedSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!MethodModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:06'!
addedSlotNamed: name ifAbsent: aBlock
	^ addedSlots at: name ifAbsent: aBlock! !

!MethodModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/28/2011 19:47'!
initialize
	addedSlots := Dictionary new! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 19:48'!
installAddedSlot: addedSlot
	addedSlots at: addedSlot name put: addedSlot! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:15'!
installModifiedSlot: modifiedSlot
	modificationMap at: modifiedSlot oldFieldIndex put: modifiedSlot! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:15'!
installRemovedSlot: removedSlot
	modificationMap at: removedSlot oldFieldIndex put: removedSlot! !

Object subclass: #LayoutAbstractScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/2/2011 14:27'!
allSlotsDo: aBlock
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 13:03'!
atName: aName
	^ self atName: aName ifAbsent: [ SlotNotFound signalForName: aName ].! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 14:04'!
atName: aName ifAbsent: aBlock
	self allSlotsDo: [ :slot | 
		slot name == aName ifTrue: [ ^ slot ]].
	^ aBlock value! !

!LayoutAbstractScope methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:25'!
extend: someSlots
	^ self extend: someSlots as: LayoutClassScope! !

!LayoutAbstractScope methodsFor: 'extending' stamp: 'CamilloBruni 4/6/2011 14:28'!
extend: someSlots as: type
	| scope fieldIndex currentParentScope nextParentScope |
	scope := type new: someSlots size.
	fieldIndex := self firstFieldIndex.
	currentParentScope := self.
	
	someSlots withIndexDo: [ :slot :slotIndex | |realSlot|
		realSlot := slot asSlot.
		nextParentScope := realSlot parentScopeFor: currentParentScope.
		nextParentScope == currentParentScope
			ifFalse: [
				currentParentScope := nextParentScope.
				fieldIndex := fieldIndex + currentParentScope ownFieldSize].
		realSlot index: fieldIndex.
		fieldIndex := fieldIndex + realSlot size.
		scope at: slotIndex put: realSlot ].
	
	scope parentScope: currentParentScope.
	^ scope! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:27'!
fieldSize
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 18:33'!
firstFieldIndex
	^ self fieldSize + 1! !

!LayoutAbstractScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/2/2011 14:28'!
flatten
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'forking' stamp: 'ToonVerwaest 4/2/2011 18:25'!
forkScope: aScope
	^ LayoutForkScope new
		parentScope: self;
		forkScope: aScope! !

!LayoutAbstractScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
hasFields
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
hasSlots
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:25'!
ownFieldSize
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'printing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
printSlotDefinitionOn: aStream
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 02:58'!
rebase: originalLayout to: newLayout
	self error: 'Should not happen'! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:50'!
visibleSlotNames
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	self subclassResponsibility! !

LayoutAbstractScope variableSubclass: #LayoutClassScope
	instanceVariableNames: 'parentScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutClassScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/1/2011 02:11'!
allSlotsDo: aBlock
	parentScope allSlotsDo: aBlock.
	self do: aBlock! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock
	self reverseDo: aBlock.
	parentScope allSlotsReverseDo: aBlock.! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 12:48'!
allVisibleSlots
	| result |
	result := parentScope allVisibleSlots.
	self do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot ]].
	^ result! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/1/2011 02:10'!
do: aBlock
	1 to: self size do: [ :index |
		aBlock value: (self at: index) ]! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:25'!
fieldSize
	^ parentScope fieldSize + self ownFieldSize.! !

!LayoutClassScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/1/2011 01:56'!
flatten
	| result |
	result := parentScope flatten.
	result addAll: self.
	^ result! !

!LayoutClassScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 12:48'!
hasFields
	self do: [ :slot | 
		slot size > 0 
			ifTrue: [ ^ true ]].
	^ parentScope hasFields! !

!LayoutClassScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 12:48'!
hasSlots
	self size > 0 
		ifTrue: [ ^ true ].
	^ parentScope hasSlots! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:26'!
ownFieldSize
	|result|
	result := 0.
	self do: [ :slot | result := result + slot size ].
	^ result! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:24'!
parentScope: anObject
	parentScope := anObject! !

!LayoutClassScope methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 18:26'!
postCopy
	parentScope := parentScope copy.
	1 to: self size do: [ :index | 
		self at: index put: (self at: index) copy ]! !

!LayoutClassScope methodsFor: 'printing' stamp: 'CamilloBruni 4/4/2011 12:48'!
printSlotDefinitionOn: aStream
	| printedAtLeastOnSlot |
	
	aStream << '{'.
	
	printedAtLeastOnSlot := false.
	
	self do: [ :slot |
		slot isVisible
			ifTrue: [
				aStream lf; tab; tab; store: slot; << '.'.
				printedAtLeastOnSlot := true.]].
			
	printedAtLeastOnSlot 
		ifTrue: [ aStream lf; tab ].
	
	aStream << '}'.! !

!LayoutClassScope methodsFor: 'reshaping' stamp: 'CamilloBruni 4/4/2011 18:16'!
rebase: originalLayout to: newLayout
	| newParent result fieldIndex |
	newParent := parentScope == originalLayout
		ifTrue: [ newLayout ]
		ifFalse: [ parentScope rebase: originalLayout to: newLayout ].
		
	result := self copy.
	result parentScope: newParent.
	
	fieldIndex := newParent firstFieldIndex.
	result do: [ :slot | 
		slot index: fieldIndex.
		fieldIndex := fieldIndex + slot size ].
	
	^ result
	! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:49'!
reverseDo: aBlock
	|size|
	size := self size.
	1 to: size do: [ :index |
		aBlock value: (self at: (1 + size - index)) ]! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 12:48'!
visibleSlotNames
	| result |
	result := OrderedCollection new.
	self do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot name ]].
	^ result asArray! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 10/16/2011 20:08'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do:
		[:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

!LayoutClassScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	aBlock value: self.
	parentScope withParentScopesDo: aBlock.! !

LayoutAbstractScope subclass: #LayoutEmptyScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

LayoutEmptyScope class
	instanceVariableNames: 'instance'!

LayoutEmptyScope class
	instanceVariableNames: 'instance'!

!LayoutEmptyScope class methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:31'!
instance
	^ instance ifNil: [ instance := self new ]! !

!LayoutEmptyScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/2/2011 14:32'!
allSlotsDo: aBlock! !

!LayoutEmptyScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:08'!
allVisibleSlots
	^ OrderedCollection new! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:31'!
fieldSize
	^ 0! !

!LayoutEmptyScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/2/2011 14:32'!
flatten
	^ OrderedCollection new! !

!LayoutEmptyScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
hasFields
	^ false! !

!LayoutEmptyScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
hasSlots
	^ false! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:26'!
ownFieldSize
	^ 0! !

!LayoutEmptyScope methodsFor: 'printing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
printSlotDefinitionOn: aStream
	aStream << '{}'! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:11'!
visibleSlotNames
	^ {}! !

!LayoutEmptyScope methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	aBlock value: self.! !

Object subclass: #NilTraitComposition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

NilTraitComposition class
	instanceVariableNames: 'instance'!

NilTraitComposition class
	instanceVariableNames: 'instance'!

!NilTraitComposition class methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 23:10'!
instance
	^ instance ifNil: [ instance := self new ]! !

!NilTraitComposition methodsFor: 'layout' stamp: 'ToonVerwaest 3/31/2011 23:00'!
composeWithLayout: aLayout
	^ aLayout! !

!NilTraitComposition methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 21:02'!
copyTraitExpression
	" ^ self "! !

Object subclass: #Slot
	instanceVariableNames: 'index name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!Slot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/22/2011 16:40'!
asSlot
	^ self new! !

!Slot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 16:35'!
named: aSymbol
	^ self new
		name: aSymbol;
		yourself! !

!Slot methodsFor: 'comparing' stamp: 'CamilloBruni 3/30/2011 18:47'!
= other
	self == other
		ifTrue: [ ^ true ].
	^ ((self species == other species) 
			and: [ index = other index ])
			and: [ name = other name]! !

!Slot methodsFor: 'converting' stamp: 'CAmi 3/15/2011 14:34'!
asSlot
	^ self! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:47'!
compileInitialize: aClass
	"nothing to do"! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 15:30'!
compileRawRead: aClass
	^ self variableNodeForClass: aClass! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:12'!
compileRawWrite: aNode to: aClass
	"^ ``(`,(self variableNodeForClass: aClass) := `,aNode) "! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
compileRead: aClass
	^ self compileRawRead: aClass! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 10/12/2011 14:11'!
compileWrite: aNode to: aClass
	"^ self compileRawWrite: aNode value to: aClass"! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 16:55'!
finalize: layout
	"nothing to do here"! !

!Slot methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 15:01'!
index
	^ index! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:16'!
index: anIndex
	index := anIndex! !

!Slot methodsFor: 'initialization' stamp: 'CamilloBruni 3/10/2011 17:17'!
initialize: instance
	"nothing to do for the default slot"! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/14/2011 19:42'!
inline
	^ self class == Slot! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:48'!
internalRead: anObject
	^ anObject instVarAt: index! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:48'!
internalWrite: aValue to: anObject
	anObject instVarAt: index put: aValue.! !

!Slot methodsFor: 'testing' stamp: 'CamilloBruni 3/30/2011 18:46'!
isVisible
	^ true! !

!Slot methodsFor: 'testing' stamp: 'CamilloBruni 3/10/2011 15:01'!
name
	^ name! !

!Slot methodsFor: 'accessing' stamp: 'MartinDias 7/29/2012 20:58'!
name: aSymbol
	name := aSymbol! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:38'!
needsField
	^ true! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/4/2011 18:41'!
parentScopeFor: aScope
	^ aScope! !

!Slot methodsFor: 'printing' stamp: 'CamilloBruni 3/30/2011 15:37'!
printOn: aStream
	aStream << self name << ' => '; << self class name.! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
read: anObject
	^ self internalRead: anObject! !

!Slot methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 14:32'!
size
	^ 1! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:59'!
storeInitializationOn: aStream
	aStream nextPutAll: self class name! !

!Slot methodsFor: 'printing' stamp: 'CamilloBruni 3/29/2011 16:36'!
storeOn: aStream
	aStream store: self name.
	aStream nextPutAll: ' => '.
	self storeInitializationOn: aStream.! !

!Slot methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 4/2/2011 19:04'!
variableNodeForClass: aClass
	^ RBVariableNode named: name! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
write: aValue to: anObject
	self internalWrite: aValue to: anObject! !

Object subclass: #SlotClassBuilder
	instanceVariableNames: 'client oldClasses newClasses classSlots globals category superclass name layoutClass slots traitComposition classTraitComposition result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!SlotClassBuilder commentStamp: '<historical>' prior: 0!
I'm responsible for building and verifying new classes. 
The update and modification/installation of classes are managed by installers (AbstractClassInstallation).

The class builder is responsible for the structural part of modifying a class or creating a new class. It relies on the installer to fetch the old version of the class. It then uses the class modification model to compute the method modification and instance modification models. It then validates if these changes are semantically sound.


Instance Variables:
	client	<PharoClassInstaller>
	oldClasses	<Collection>
	newClasses	<Collection>
	classSlots	<ProtoObject | PseudoContext>
	globals	<ProtoObject | PseudoContext>
	category	<ProtoObject | PseudoContext>
	superclass	<Behavior>
	name	<(DependentsArray of: Character) | IRSequence | Path | (SequenceableCollection of: Character) | TextLine>
	layoutClass	<ProtoObject | PseudoContext>
	slots	<ProtoObject | PseudoContext>
	traitComposition	<ProtoObject | PseudoContext>!

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:27'!
apply: classModification
	classModification modifiesSlots
		ifTrue: [self applySlotChange: classModification]
		ifFalse: [ 
			classModification modifiesFormat
				ifTrue: [ self applyFormatChange: classModification]
				ifFalse: [
					classModification modifiesSuperclass
						ifTrue: [ self applySuperclassChange: classModification ]
						ifFalse: [ ^ self installTraitComposition: classModification ]]].
	
	client
		migrateClasses: oldClasses asArray
		to: newClasses asArray
		using: classModification instanceModification.
	
	self installTraitComposition: classModification.
		
	oldClasses removeAll.
	newClasses removeAll.! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:26'!
applyAndNotify: classModification
	| old new |
	old := classModification target.
	new := classModification apply.
	
	" Notify the system of the change "
	client shallowClassDefinitionChangedFrom: old to: new by: classModification.

	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.
	^ new! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:41'!
applyAndUpdateFormat: classModification
	| old new |
	old := classModification target.
	new := classModification apply.
	
	" Notify the system of the change "
	client classFormatChangedFrom: old to: new by: classModification.

	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.
	^ new! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 3/31/2011 19:56'!
applyAndUpdateMethods: classModification
	| old new |
	old := classModification target.
	new := classModification apply.
	
	" Notify the system of the change "
	client classDefinitionChangedFrom: old to: new by: classModification.

	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.
	^ new! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:18'!
applyFormatChange: classModification
	result := self applyAndUpdateFormat: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateFormat: propagation ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:18'!
applyPropagations: classModification
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateMethods: propagation ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:18'!
applySlotChange: classModification
	result := self applyAndUpdateMethods: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateMethods: propagation ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:27'!
applySuperclassChange: classModification
	result := self applyAndNotify: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndNotify: propagation ]! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/2/2011 14:37'!
build
	| oldClass metaChange classChange |
	result := oldClass := client classAt: name ifAbsent: [ ^ self buildNewClass ].

	self validateSuperChain: oldClass.
	
	metaChange := ClassModification
							modify: oldClass class
							extend: self metaOfSuper
							withLayoutType: PointerLayout
							slots: classSlots
							traitComposition: classTraitComposition.
	
	classChange := ClassModification
							modify: oldClass
							extend: superclass
							withLayoutType: layoutClass
							slots: slots
							traitComposition: traitComposition.
	
	self apply: metaChange.
	self apply: classChange.

	result isMeta ifFalse: [
		client recategorize: result to: category ].
	
	^ result! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 15:57'!
buildNewClass
	| metaclass newClass |
	metaclass := Metaclass new.
	metaclass
		superclass: self metaOfSuper
		withLayoutType: PointerLayout
		slots: classSlots.

	newClass := metaclass new.
	newClass setName: name.
	
	newClass
		superclass: superclass
		withLayoutType: layoutClass
		slots: slots.
			
	client classAdded: newClass inCategory: category.
	
	^ newClass! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
category: aCategory
	category := aCategory! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
classSlots: someClassSlots
	classSlots := someClassSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 20:53'!
classTraitComposition: aTraitComposition
	classTraitComposition := aTraitComposition asTraitComposition! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
client: aClient
	client := aClient! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
globals: globalsArray
	globals := globalsArray! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'GuillermoPolito 7/30/2012 22:23'!
initialize
	super initialize.
	oldClasses := OrderedCollection new.
	newClasses := OrderedCollection new.
	globals := {}.
	classSlots := {}.
	slots := {}.
	layoutClass := PointerLayout.
	superclass := Object.
	classTraitComposition := NilTraitComposition instance.
	traitComposition := NilTraitComposition instance.! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 3/31/2011 21:14'!
installTraitComposition: classModification
	client
		installTraitComposition: classModification traitComposition
		on: result! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 8/6/2012 11:24'!
invalidGlobalNameError: description
	"Throw a name validation exception"
	
	^ InvalidGlobalNameConflict new signal: description! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
layoutClass: aLayoutClass
	layoutClass := aLayoutClass! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
metaOfSuper
	 ^ superclass ifNil: [ Class ] ifNotNil: [ superclass class ].! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
name: aName
	name := aName.
	self validateClassName.! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
slots: someSlots
	slots := someSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
superclass: aSuperclass
	superclass := aSuperclass.
	superclass ifNotNil: [ self validateClass: superclass ].
	client environment: superclass environment! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 20:09'!
traitComposition: aTraitComposition
	traitComposition := aTraitComposition asTraitComposition! !

!SlotClassBuilder methodsFor: 'validating' stamp: 'ToonVerwaest 3/28/2011 00:29'!
validateClass: aClass
	aClass isBehavior
		ifFalse: [ self error: 'Trying to build classes from non-class objects' ].
	aClass isMeta
		ifTrue: [ self error: 'Metaclasses cannot be used for building classes' ].! !

!SlotClassBuilder methodsFor: 'validating' stamp: 'MartinDias 7/31/2012 23:34'!
validateClassName
	name isSymbol ifFalse: [
		self invalidGlobalNameError: 'Class name should be a symbol.' ].
	name first canBeGlobalVarInitial ifFalse: [
		self invalidGlobalNameError: 'Class name does not start with a valid Global Var Initial.' ].! !

!SlotClassBuilder methodsFor: 'validating' stamp: 'MartinDias 8/6/2012 11:23'!
validateSuperChain: oldClass
	superclass ifNil: [ ^ nil ].
	superclass withAllSuperclassesDo: [ :class |
		class == oldClass
			ifTrue: [ CircularHierarchyConflict signal: 'Trying to build a circular hierarchy' ]].! !

Object subclass: #SlotVirus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Transformation'!

!SlotVirus commentStamp: 'CAmi 3/15/2011 15:47' prior: 0!
I am used to spread slot into an unaffected system. 

   SlotVirus spread.

Initializes default slots and layouts on all objects (note: so far this will break custom objects with custom slots)!

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:17'!
basicLayoutFor: aClass
	aClass isBits
		ifTrue: [
			aClass isBytes ifTrue: [ ^ aClass superclass layout extendByte ].
			 ^ aClass superclass layout extendWord ].
	
	aClass isWeak 
		ifTrue: [ ^ self basicWeakLayoutFor: aClass  ].
	
	aClass isVariable 
		ifTrue: [ ^ self basicVariableLayoutFor: aClass ].
	
	^ aClass superclass layout extend: (self layoutScopeFor: aClass).! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicLayoutScopeFor: aClass
	^ aClass superclass layout slotScope extend: (aClass instVarNames ifNil: [ #() ])! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicVariableLayoutFor: aClass
	^ aClass superclass layout extendVariable: (self layoutScopeFor: aClass)! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicWeakLayoutFor: aClass
	^ aClass superclass layout extendWeak: (self layoutScopeFor: aClass)! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:28'!
checkAllLayouts
	(SystemNavigation default allClasses sort: [:a :b| a name <= b name])
		do: [ :cls|
			self checkLayoutOfClass: cls.
			self checkLayoutOfClass: cls class.]! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:22'!
checkDuplicateClass: cls
	cls isMeta 
		ifTrue: [ ^ self ].
	(Smalltalk includesKey: cls name)
		ifFalse: [ ^ self].
	((Smalltalk at: cls name) == cls)
		ifFalse: [ cls becomeForward: (Smalltalk at: cls name)].! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:12'!
checkInheritedSlots: cls
	| mySlot |
	cls superclass 
		ifNil: [ ^ self ].
		
	(cls superclass layout size <= cls layout size)
		ifFalse: [
			self error: (cls name, ' does not inherit all slots from ', cls superclass name).
			^ self].
	
	cls superclass layout allSlots withIndexDo: [ :slot :index|
		mySlot := (cls layout slotAt: index).
		self haltIf: slot index ~= mySlot index.
		self haltIf: slot name ~= mySlot name].! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:11'!
checkLayout: aClass 
	(aClass withAllSubclasses sort: [:a :b| a name <= b name])
		do: [ :cls|
			self checkLayoutOfClass: cls.
			self checkLayoutOfClass: cls class.]! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 15:02'!
checkLayoutOfClass: cls
	self checkDuplicateClass: cls.
	self assert: cls layout isNil not.
	"self assert: cls format == cls layout format."
	cls layout checkSanity.
	cls layout hasSlots 
		ifFalse: [ ^ self].
		
	cls isMeta
		ifFalse: [ 
			(cls superclass subclasses includes: cls)
				ifFalse: [
					"self error: (cls name, ' is not properly registered as sublclass of ', cls superclass name)."
					self fixSuperclassSubclasses: cls]].
		
	self checkInheritedSlots: cls.
	
	self checkSlotsIndices: cls! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:14'!
checkSlotsIndices: cls
	cls layout allSlots withIndexDo: [ :slot :index|
		self assert: slot name isNil not.
		self flag: 'fix slot indexing..'
		"self assert: slot index = ((cls layout fixedSizeUpToIndex: index) + 1).
		slot index: ((cls layout fixedSizeUpToIndex: index) + 1)"]! !

!SlotVirus class methodsFor: 'fixing' stamp: 'CamilloBruni 3/31/2011 14:16'!
fixSuperclassSubclasses: cls
	|collection newSubclasses|
	cls superclass 
		ifNil: [ ^ self ].
	cls superclass addSubclass: cls.
	! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:31'!
installLayoutVariable
	(ClassDescription allInstVarNames includes: #layout) ifTrue: [ ^ self ].
	ClassDescription addInstVarNamed: #layout.! !

!SlotVirus class methodsFor: 'installing' stamp: 'MartinDias 7/29/2012 20:36'!
installNewLayouts
	ProtoObject
		instVarNamed: #layout
		put: ((NilLayout instance extend: #()) host: ProtoObject).
		
"	self flag: 'I do not like PseudoContext'.
	PseudoContext
		instVarNamed: #layout
		put: ((NilLayout instance extend: #()) host: ProtoObject)."

	ProtoObject allSubclassesDo: [ :aSubclass |
		aSubclass
			instVarNamed: #layout
			put: (self newLayoutFor: aSubclass) ].
		
	SmallInteger
		instVarNamed: #layout
		put: (SmallIntegerLayout new).
		
	CompiledMethod
		instVarNamed: #layout
		put: (CompiledMethodLayout new).! !

!SlotVirus class methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 15:26'!
invalidClasses
	| result |
	result := OrderedCollection new.
	ProtoObject withAllSubclassesDo: [ :aClass |
		aClass format ~~ aClass layout format ifTrue: [ result add: aClass ]].
	^ result! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:42'!
layoutScopeFor: aClass
	^ self basicLayoutScopeFor: aClass! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:56'!
newLayoutFor: aClass

	|aLayout|
	
	aLayout := (self basicLayoutFor: aClass).
	aLayout := aClass traitComposition composeWithLayout: aLayout.
		
	"fill in the instvars without triggering any slots"
	^ aLayout
		instVarNamed: #host put: aClass;
		instVarNamed: #compactClassIndex put: aClass indexIfCompact;
		yourself! !

!SlotVirus class methodsFor: 'fixing' stamp: 'CamilloBruni 10/16/2011 19:41'!
refresh
	Slot recompileAll.
	AbstractLayout recompileAll.
	SlotObject recompileAll.
	SlotTest recompileAll.
	SlotModifier recompileAll.! !

!SlotVirus class methodsFor: 'fixing' stamp: 'CamilloBruni 3/28/2011 18:07'!
removeBrokenDoIts
	SystemNavigation default allClassesDo: [ :cls|
		cls methodDict removeKey: #DoItIn: ifAbsent: []].! !

!SlotVirus class methodsFor: 'installing' stamp: 'MartinDias 7/29/2012 20:44'!
spread
	self installLayoutVariable.
	self installNewLayouts.
	
	SystemNavigation default allClasses 
		do: [ :cls|
			cls initializeLayout.
			cls class initializeLayout]
		displayingProgress:[:aClass| 'Processing ', aClass name].
	
	AbstractLayout withAllSubclassesDo: [ :s |
		s allInstances do: [ :aLayout |
			self flag: #todo. "Remove the next if moving initialization code to AbstractLayout class."
			aLayout host ifNotNilDo: [ :host |
				aLayout instVarNamed: #compactClassIndex put: host indexIfCompact ] ]].! !

!ClassDescription methodsFor: '*Slot' stamp: 'GuillermoPolito 4/30/2012 18:17'!
definition
	"Answer a String that defines the receiver."

	| aStream |
	aStream := (String new: 800) writeStream.
	superclass == nil
		ifTrue: [aStream nextPutAll: 'ProtoObject']
		ifFalse: [aStream nextPutAll: superclass name].
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	(self hasTraitComposition) ifTrue: [
		aStream cr; tab; nextPutAll: 'uses: ';
			nextPutAll: self traitCompositionString].
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: self category asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 10/18/2011 15:10'!
initializeLayout
	(self allInstVarNames includes: #layout) 
		ifFalse: [ ^ self ].
		
	layout isNil ifFalse: [ ^ self ].
	
	self superclass isNil 
		ifFalse: [ self superclass initializeLayout ].
	
	layout := SlotVirus newLayoutFor: self! !

!ClassDescription methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 18:33'!
initializeLayoutWithSlots: slots
	| offset superlayout|
	superlayout := superclass layout.
	offset := superlayout size.
	
	"create the new layout and copy in the super slots"
	layout := self layoutSized: slots size + offset.
	layout replaceFrom: 1 to: offset with: superlayout.
	
	"create new slots"
	slots withIndexDo: [ :slot :index|
		layout at: offset + index put: slot asSlot].
	layout finalize.
	
	"backup solution to create instvar names"
	instanceVariables := Array new: slots size.
	1 to: slots size do: [ :index| 
		instanceVariables at: index put: (layout at: index + offset) name].! !

!ClassDescription methodsFor: '*Slot' stamp: 'CAmi 3/14/2011 19:37'!
layout
	^ layout! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 3/30/2011 19:21'!
layoutSized: size
	|layoutInstance layoutClass|
	layoutClass := PointerLayout.
	
	self isBits
		ifTrue: [
			self isBytes
				ifTrue: [ layoutClass := ByteLayout ].
			self isWords 
				ifTrue: [ layoutClass := WordLayout ]]
		ifFalse: [
			self isVariable ifTrue: [ layoutClass := VariableLayout ].
			self isWeak ifTrue: [ layoutClass := WeakLayout ]].
	
	layoutInstance := layoutClass new: size.
	layoutInstance host: self.
	
	^ layoutInstance! !

!ClassDescription methodsFor: '*Slot' stamp: 'GuillermoPolito 7/31/2012 02:09'!
newInstanceFrom: oldInstance variable: variable size: instSize map: map
	"Create a new instance of the receiver based on the given old instance.
	The supplied map contains a mapping of the old instVar names into
	the receiver's instVars"
	| new |
	variable
		ifTrue: [new := self basicNew: oldInstance basicSize]
		ifFalse: [new := self basicNew].
	1 to: instSize do: 
		[:offset |  
		map isArray ifTrue: [
			(map at: offset) > 0 ifTrue:
				[new instVarAt: offset
						put: (oldInstance instVarAt: (map at: offset))]
		] ifFalse: [ | slotModification |
			slotModification := map modificationAt: offset.
			slotModification migrateAt: offset to: new from: oldInstance
		]
	].
	variable 
		ifTrue: [1 to: oldInstance basicSize do: 
					[:offset |
					new basicAt: offset put: (oldInstance basicAt: offset)]].
	^new! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 8/6/2012 17:44'!
slotDefinition
	"Answer a String that defines the receiver."
 	
	| aStream |
	aStream := (String new: 300) writeStream.
	aStream store: self.
	^ aStream contents! !

!ClassDescription methodsFor: '*Slot' stamp: 'CAmi 3/18/2011 12:42'!
slotDefinitionOn: aStream
	layout printSlotDefinitionOn: aStream.! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 7/28/2012 15:38'!
slotStoreOn: aStream
	superclass == nil
		ifTrue: [aStream nextPutAll: 'ProtoObject']
		ifFalse: [aStream nextPutAll: superclass name].
		
	aStream << ' subclass: '; store: self name.
	
	aStream lf; tab; << 'layout: '; << self layout class name .
			
	(self hasTraitComposition and: [self traitComposition notEmpty]) 
		ifTrue: [aStream cr; tab. aStream << 'uses: ' << self traitCompositionString].
		
	aStream lf; tab; << 'slots: '.
	self slotDefinitionOn: aStream.
			
	aStream lf; tab; << 'classSlots: '.
	self class slotDefinitionOn: aStream.
			
	aStream lf; tab; << 'globals: ';
		store: self sharedPoolsString.
			
	aStream lf; tab; << 'category: '; 
		print: (SystemOrganization categoryOfElement: self name).

	superclass ifNil: [ 
		aStream nextPutAll: '.'; lf.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'].! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 3/25/2011 00:40'!
subclass: className layout: aLayoutClass slots: slotCollection classSlots: classSlotCollection globals: poolDictString category: categoryName
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver)."
	^ PharoClassInstaller make: [:builder|
		builder
			superclass: self;
			name: className;
			layoutClass: aLayoutClass;
			classSlots: classSlotCollection;
			category: categoryName;
			globals: poolDictString;
			slots: slotCollection
		]
		
! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 7/30/2012 01:49'!
superclass: aSuperclass layout: aLayout
	layout := aLayout. 
"	layout host: self. --> this is done in #buildFrom:scope:host:"
	
	self
		superclass: aSuperclass
		methodDictionary: MethodDictionary new
		format: aLayout format.
	
	instanceVariables := layout instanceVariables asArray! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 7/30/2012 01:49'!
superclass: aSuperclass withLayoutType: layoutType slots: slotArray
	| superLayout newScope newLayout |
	superLayout := aSuperclass
						ifNil: [ NilLayout instance ]
						ifNotNil: [ aSuperclass layout ].
	newScope := superLayout slotScope extend: slotArray.
	newLayout := layoutType buildFrom: superLayout scope: newScope host: self.
	newLayout checkSanity.
	self
		superclass: aSuperclass
		layout: newLayout! !
